%define slib_version 2c5
%define scm_version 5d0

Summary: scheme library and scheme interpreter
Name: scm-slib
Version: %{scm_version}
Release: 2
Copyright: GPL
Group: Development/Languages/Scheme
Source: ftp://ftp-swiss.ai.mit.edu/pub/scm/scm%{scm_version}.tar.gz
Source1: ftp://ftp-swiss.ai.mit.edu/pub/scm/slib%{slib_version}.tar.gz
Source2: ftp://ftp-swiss.ai.mit.edu/pub/scm/r5rs.txi
Patch: scm-5d0-texi.patch
Patch1: r5rs.txi.patch
Patch2: slib-2c5-texi.patch
BuildRoot: /var/tmp/%{name}-%{version}
%define prefix /usr

%description
Scm is a portable Scheme implementation written in C.
SLIB is a portable scheme library meant to provide compatibility and
utility functions for all standard scheme implementations.
Both conform to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%package -n slib
Summary: portable scheme library
Version: %{slib_version}
Group: Development/Languages/Scheme
URL: http://swissnet.ai.mit.edu/~jaffer/SLIB.html

%description -n slib
SLIB is a portable scheme library meant to provide compatibility and
utility functions for all standard scheme implementations.
It conforms to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%package -n scm
Summary: scm scheme implementation
Version: %{scm_version}
Group: Development/Languages/Scheme
URL: http://swissnet.ai.mit.edu/~jaffer/SCM.html
Requires: slib >= 2c3

%description -n scm
Scm is a portable Scheme implementation written in C.
It conforms to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%changelog

* Tue Mar 02 1999 W. L. Estes <wlestes@tarvalon.uncg.edu>
- use %%define prefix to get some relocateability
- we require only slib >= 2c3 (the first slib package done reasonably)
- drop patch to r5rs.txi, let the sections go as is
- drop html/texi docs
- patch scm.texi, slib.texi, r5rs.txi  for cross refs and typos

* Fri Feb 23 1999 Jos Romildo Malaquias <romildo@iceb.ufop.br>
- initial build integrating slib and scm

%prep
%setup -q -c -a1 -n scm-slib
cp %SOURCE2 scm
%patch -p0 -b .fix-texi
%patch1 -p0 -b .fix-texi
%patch2 -p0 -b .fix-texi

%build

cat > slib.sh << EOF
SCHEME_LIBRARY_PATH=%{prefix}/share/slib/
export SCHEME_LIBRARY_PATH
EOF
chmod 755 slib.sh

cat > scm.sh << EOF
SCM_INIT_PATH=%{prefix}/share/scm/Init%{scm_version}.scm
export SCM_INIT_PATH
EOF
chmod 755 scm.sh

cd scm
export SCHEME_LIBRARY_PATH=`pwd`/../slib/
export SCM_INIT_PATH=`pwd`/Init%{scm_version}.scm
make scmlit
./scmlit -f build -e'(bi)' build > makescm
. ./makescm
#lifted from Makefile
./scmlit -r database-browse -l build.scm -e "(browse build 'platform)" > platform.txi
make version.txi
makeinfo scm.texi
makeinfo r5rs.txi

cd ../slib
make version.txi
PATH="../scm:$PATH" make htmlform.txi
makeinfo slib.texi

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{usr/{man,info,bin,share/{slib,scm}},etc/profile.d}

cd slib
cp -p *.scm *.init *.pat *.sh $RPM_BUILD_ROOT/usr/share/slib
gzip --name *.info*
cp -p slib.info* $RPM_BUILD_ROOT/usr/info
cd ..

# the cd commands make the blocks easier to move around (defensive programming)

cd scm
make install prefix=$RPM_BUILD_ROOT/usr/ IMPLPATH=$RPM_BUILD_ROOT/usr/share/scm/
cp -pf *.scm pi.c implcat slibcat $RPM_BUILD_ROOT/usr/share/scm
cp -pf .gdbinit $RPM_BUILD_ROOT/usr/share/scm
gzip --name *.info*
cp -p *.info* $RPM_BUILD_ROOT/usr/info
cd ..

cp -p *.sh $RPM_BUILD_ROOT/etc/profile.d

%clean
rm -rf $RPM_BUILD_ROOT

%post -n slib
install-info %prefix/info/slib.info.gz %prefix/info/dir

%preun -n slib
install-info --delete %prefix/info/slib.info.gz %prefix/info/dir

%post -n scm
for i in r5rs scm ; do
install-info %prefix/info/$i.info.gz %prefix/info/dir
done

%preun -n scm
for i in scm r5rs ; do
install-info --delete %prefix/info/$i.info.gz %prefix/info/dir
done

%files -n slib
%defattr (-, root, root)
%doc ANNOUNCE ChangeLog FAQ README
/etc/profile.d/slib.sh
%prefix/info/slib.info*.gz
%prefix/share/slib

%files -n scm
%defattr (-, root, root)
%doc QUICKREF README ANNOUNCE ChangeLog
/etc/profile.d/scm.sh
%prefix/bin/*
%prefix/info/r5rs.info*.gz
%prefix/info/scm.info*.gz
%prefix/man/*/*
%prefix/share/scm
